'Main.inc

%EDIT_SET_X_INT           = 1500
%BTN_SET_X_INT            = 1505
%EDIT_GET_X_INT           = 1510
%BTN_GET_X_INT            = 1515
%EDIT_SET_X_TEXT          = 1520
%BTN_SET_X_TEXT           = 1525
%EDIT_GET_X_TEXT          = 1530
%BTN_GET_X_TEXT           = 1535

%EDIT_SET_Y_INT           = 1540
%BTN_SET_Y_INT            = 1545
%EDIT_GET_Y_INT           = 1550
%BTN_GET_Y_INT            = 1555
%EDIT_SET_Y_TEXT          = 1560
%BTN_SET_Y_TEXT           = 1565
%EDIT_GET_Y_TEXT          = 1570
%BTN_GET_Y_TEXT           = 1575


Type WndEventArgs
  wParam                  As Long
  lParam                  As Long
  hWnd                    As Dword
  hInst                   As Dword
End Type


Type MessageHandler
  wMessage                As Long
  dwFnPtr                 As Dword
End Type

Declare Function FnPtr(wea As WndEventArgs) As Long
Global MsgHdlr() As MessageHandler

Sub Cls(hStdOut As Dword)
  Local csbi As CONSOLE_SCREEN_BUFFER_INFO
  Local dwConsoleSize As Dword
  Local dwWritten As Dword
  Local cdXY As COORD

  Call GetConsoleScreenBufferInfo(hStdOut,csbi)
  dwConsoleSize=csbi.dwSize.X * csbi.dwSize.Y
  Call FillConsoleOutputCharacter(hStdOut,32,dwConsoleSize,cdXY,dwWritten)
  Call GetConsoleScreenBufferInfo(hStdOut,csbi)
  Call FillConsoleOutputAttribute(hStdOut,csbi.wAttributes,dwConsoleSize,cdXY,dwWritten)
  Call SetConsoleCursorPosition(hStdOut,cdXY)
End Sub


Sub Locate(hStdOutput As Dword, x As Integer, y As Integer)
  Local cdXY As COORD
  cdXY.x=x : cdXY.y=y
  Call SetConsoleCursorPosition(hStdOutput,cdXY)
End Sub


Sub Waitkey()
  Local dwInputEvents As Dword
  Local blnContinue As Long
  Local hStdInput As Dword
  Local ir As INPUT_RECORD
  
  hStdInput=GetStdHandle(%STD_INPUT_HANDLE)
  FlushConsoleInputBuffer(hStdInput)
  blnContinue=%TRUE
  Do While blnContinue=%TRUE
     Call ReadConsoleInput(hStdInput,ir,1,dwInputEvents)
     If ir.EventType=%KEY_EVENT Then
        blnContinue=%FALSE
     End If
  Loop
End Sub


Sub Prnt(strLn As String, blnCrLf As Long)
  Local iLen, iWritten As Long
  Local hStdOutput As Dword
  Local strNew As String
  
  hStdOutput=GetStdHandle(%STD_OUTPUT_HANDLE)      
  If blnCrLf Then
     strNew=strLn + $CrLf
  End If
  iLen = Len(strNew)
  WriteConsole(hStdOutput, Byval Strptr(strNew), iLen, iWritten, Byval 0)
End Sub


